/*
 * Este programa ilustra a programacao concorrente em Java.
 * O metodo main cria 2 threads que executam em
 * concorrencia com a thread principal. 
 * Cada thread adiciona caracteres a um array global compartilhado. 
 * No final do programa, imprime-se o numero de caracteres
 * de cada tipo armazenados no array. 
 * O resultado correto deve ser: A=50 B=50 C=50
 *
 * ATENCAO: Este programa esta errado, porque nao controla
 * o acesso ao dado compartilhado pelas threads.
 */

import java.util.Arrays;

// Array compartilhado. 
class SharedArray {
	
      private char[] global_array;
      private int global_ind = 0;

      public SharedArray(int n) {
         global_array = new char[n];
         Arrays.fill(global_array, '-');
      }

      public void addChar(char c) {
         global_array[global_ind] = c;
         TimeSpend.run();
         global_ind++;
      }

      public int countOccurrences(char c) {
         int count = 0;
         for (int i = 0; i < global_array.length; i++)
            if (global_array[i] == c)
               count++;
         return count;
      }


}

// Classe auxiliar.
class TimeSpend {
      public static void run() {
         for (int i = 0; i < 10000; i++)
            for (int j = 0; j < 10; j++)
            {}
      }
}


// Classe que define a tarefa executada por 1 thread.
class ArrayWorker extends Thread {
	
      private SharedArray a;
      private int count; 
      private char c;
	
      ArrayWorker(SharedArray a, int count, char c) { 
         this.a = a;
         this.count = count;
         this.c = c;
      }
	
      public void run() {
         for (int i = 0; i < count; i++) {
            TimeSpend.run();
            a.addChar(c);
         }
      }	
}

// Classe principal.
class ExThreadsABC {
	
      static final int MaxThreadChar = 50;

      public static void main(String[] args) {
	
         try {

            SharedArray array = new SharedArray(MaxThreadChar*3);
		
            ArrayWorker t1 = new ArrayWorker(array, MaxThreadChar, 'A');
            ArrayWorker t2 = new ArrayWorker(array, MaxThreadChar, 'B');
            ArrayWorker t3 = new ArrayWorker(array, MaxThreadChar, 'C');
		
            t1.start();
            t2.start();
            t3.run();

            t1.join();
            t2.join();

            System.out.println("A=" + array.countOccurrences('A') + " " +
                               "B=" + array.countOccurrences('B') + " " +
                               "C=" + array.countOccurrences('C'));

         } catch (InterruptedException e) { } 
      }
	
}
